/*
Toradex AG

CoProcLib.h
Header file for the free avilible CoProc Lib

Requires:
- KernelCallbackLib.lib

*/

#ifndef __COPROC_LIB_H__
#define __COPROC_LIB_H__

#ifdef __cplusplus
extern "C" {
#endif


#define CPL_VER_MAJ     1
#define CPL_VER_MIN     0
#define CPL_BUILD       0


//Defines for getPROCID
#define TYPE_PXA270		0x11
#define TYPE_MONAHANS	0x02
#define TYPE_PXA320		0x02
#define TYPE_PXA300		0x08
#define TYPE_PXA310		0x09

/*
Get CLKCFG (Coprocessor 14, cr6)
Core Clock Configuration
*/
DWORD getCLKCFG();

/*
Sets CLKCFG (Coprocessor 14, cr6)
Core Clock Configuration
*/
void setCLKCFG(DWORD);

/*
Get PWRMODE (Coprocessor 14, cr7)
Power Modes
*/
DWORD getPWRMODE();

/*
Set PWRMODE (Coprocessor 14, cr7)
Power Modes
*/
void setPWRMODE(DWORD);

/*
Gets CPUID (Coprocessor 15, cr0)
Prozessor information
*/
DWORD getCPUID();

/*
Get Processor ID
Use this function to dedect on which processor your programm is  running
*/
DWORD getPROCID();

/*
Check if L2 cache are enabled
TRUE: Enabled False: disabled
*/
DWORD getL2Enabled();


#ifdef __cplusplus
}
#endif

#endif // __COPROC_LIB_H__